//ACTION_URL
var ACTION_URL = "http://yt.xuanchuan100.com/app";

var TIMEOUT = 10000;//设置网络超时时间10s
var UPLOAD_TIMEOUT = 30000;//文件上传网络超时时间30s
var ANISHOW = "pop-in";//"slide-in-right";//切换页面动画效果
var SCENE_MODE = "0";//场景

(function($, mui, owner) {
	/**
	 * 设置应用本地配置
	 **/
	owner.setStorage = function(key,val) {
		localStorage.setItem(key,val);
	};
	/**
	 * 获取应用本地配置
	 **/
	owner.getStorage = function(key) {
		return localStorage.getItem(key);
	};
	/**
	 * 删除应用本地配置
	 **/
	owner.removeStorage = function(key) {
		localStorage.removeItem(key);
	};
	/**
	 * 获取本地用户信息
	 **/
	owner.settings = {
		toKen : owner.getStorage("toKen"),
		userPhone　:　owner.getStorage("userPhone"),
		curClientCode　: owner.getStorage("curClientCode"),
		curSellerName :　owner.getStorage("curSellerName")
	}
	
	/**
	 * 请求遮罩蒙版
	 **/
	owner.myMask = function(){
		if($("#myMask").length == 0){
			var htmlStr = '';
			htmlStr += '<div id="myMask" style="display:none;position:fixed;top:0;right:0;bottom:0;left:0;z-index:9999;background-color:rgba(0,0,0,.25);">';
			htmlStr += '<span class="mui-spinner" style="position:fixed;top:50%;left:50%;z-index:9999;width:30px;height:30px;margin:-15px 0 0 -15px;">';
			htmlStr += '</span>';
			htmlStr += '</div>';
			setTimeout(function(){
				$("body").append(htmlStr);
			},0)
		}
		return $("#myMask");
	}();
	owner.setRemSize = function(){
		//自适应rem(在iphone6的屏幕下，1rem = 10px)
		var deviceWidth = owner.getStorage("fontSzie");
		if(!deviceWidth){
			deviceWidth = document.documentElement.clientWidth;
			if (deviceWidth > 640) { deviceWidth = 640; };
			owner.setStorage("fontSzie",deviceWidth);
		}
		//document.documentElement.style.fontSize = deviceWidth / 37.5 +'px';
	};
	/**
	 * 获取设备类型 Android OR ios
	 **/
	owner.getOsName = function(){
		if (mui.os.ios) {
			return "iOS";
		}else if(mui.os.android) {
			return "Android";
		}else{
			return "";
		}
	};
	/**
	 * 获取距今n天的日期 mm/dd
	 **/
	owner.NDays = function(n){
		var time = new Date();
		var newTime=time-n*24*60*60*1000;
		var _date = new Date(newTime);
		var _m = (_date.getMonth()+1) < 10 ?  "0"+(_date.getMonth()+1) : (_date.getMonth()+1);
		var _day = _date.getDate()<10 ?  "0"+ _date.getDate() : _date.getDate();
		return _m+'/'+_day;
	};
	/**
	 * 获取距今n月的月份 yy/mm
	 **/
	owner.Mdays = function(n){
		var time = new Date();
		var _y = time.getFullYear();
		var _m = time.getMonth() + 1 - n % 12 ;
		_m = _m <= 0 ? 12 + _m : _m;
		if(time.getMonth()+ 1 - n <= 0){
			_y = _y - 1 - Math.floor((n - time.getMonth() - 1) / 12);
		}
		_m = _m < 10 ?  "0"+_m : _m;
		return _y+'/'+ _m;
	};
	/**
	 * 获取距今n天的日期  yy/mm/dd
	 **/
	owner.FDays = function(n){
		var time = new Date();
		var newTime=time-n*24*60*60*1000;
		var _date = new Date(newTime);
		var _m = (_date.getMonth()+1) < 10 ?  "0"+(_date.getMonth()+1) : (_date.getMonth()+1);
		var _day = _date.getDate()<10 ?  "0"+ _date.getDate() : _date.getDate();
		return _date.getFullYear()+'/'+_m+'/'+_day;
	};
	 /**
	 * 验证手机号
	 **/
	owner.isPhoneNum = function(phone) { 
		var pattern = /^1[3|4|5|7|8]\d{9}$/; 
		return pattern.test(phone);
	};
	/**
	 * 退出程序
	 **/
	owner.oldBack = mui.back;
	owner.muiQuit = function(){
		var first=null;  
		mui.back=function(){  
			if(!first){
				first=new Date().getTime();  
				mui.toast('再按一次退出系统!');
				setTimeout(function(){  
					first=null;
				},2000);  
			}else{
				if(new Date().getTime()-first<2000){  
					plus.runtime.quit();  
				}  
			} 
		};
	};
	//跳转页面的函数
	owner.muiBack = function(url){
		mui.back=function(){
			window.location.href=url;
		};
	}
	/**
	 * 退出登录
	 **/
	owner.logOut = function(){
		$.ajax({
			type: "post",
			async:true,
			url: ACTION_URL+"/loginOut",
			data: {
				token:app.getStorage("toKen")
			},
			dataType : "json",
			success: function(dat) {//请求成功后的回调函数
				if(dat.statusCode = 200){
					owner.removeStorage("curClientCode");//删除网点代码
					owner.removeStorage("toKen");
					window.location.href = "../views/login.html";
				}else{
					mui.toast("服务器开小差啦！请稍后再试");
					return;
				}
			},
			error:function(xhr,type,errorThrown){//请求失败后的回调函数
				mui.toast("服务器开小差啦！请稍后再试");
				return;
			}
		});
	};
	/**
	 * 预加载模板
	 **/
	owner.getTemplate = function(name, header, content) {
		var template = templates[name];
		if (!template) {
			//预加载共用父模板；
			var headerWebview = mui.preload({
				url: header,
				id: name + "-main",
				styles: {
					popGesture: "hide",
				},
				extras: {
					mType: 'main'
				}
			});
			//预加载共用子webview
			var wubWebviewH = $("body").width() * 0.20;
			var subWebview = mui.preload({
				url: !content ? "" : content,
				id: name + "-sub",
				styles: {
					popGesture: "none",
					top: '74px',
					bottom: wubWebviewH + 'px',
					background:"transparent"
				},
				extras: {
					mType: 'sub'
				}
			});
			subWebview.addEventListener('titleUpdate', function() {
				setTimeout(function() {
					subWebview.show();
				}, 50);
			});
			subWebview.hide();
			headerWebview.append(subWebview);
			//iOS平台支持侧滑关闭，父窗体侧滑隐藏后，同时需要隐藏子窗体；
			if (mui.os.ios) { //5+父窗体隐藏，子窗体还可以看到？不符合逻辑吧？
				headerWebview.addEventListener('hide', function() {
					subWebview.hide("none");
				});
			}
			templates[name] = template = {
				name: name,
				header: headerWebview,
				content: subWebview,
			};
		}
		return template;
	};
	
	
})(jQuery,mui,window.app = {});

