var FillChart = function(ele, opt) {
	this.$ele = $(ele);
	this.options = opt;
}
FillChart.prototype = {
	init: function() {
		var myChart = echarts.init(document.getElementById(this.$ele.attr('id')));
		if(this.options.type == 'pie'){//判断图表类型是饼图
			myChart.setOption(this.pie());
		}
		if(this.options.type == 'line'){//判断图表类型是折线图
			myChart.setOption(this.line());
		}
		if(this.options.type == 'dateZoomline'){
			myChart.setOption(this.dateZoomline());
		}
	},
	line:function(){
		var _option = {
            tooltip: {//提示框组件
				show:false,//不显示
			},
			grid:{//直角坐标系内绘图网格
				left:'0',//组件离容器左侧的距离
				top:'30',
				right:'0',
				bottom:'0',
				containLabel:true//grid 区域是否包含坐标轴的刻度标签
			},
            xAxis: {//直角坐标系 grid 中的 x 轴
				axisLine: {//坐标轴轴线
					show : false//是否显示坐标轴轴线
				},
				axisTick:{//坐标轴刻度
					show : false//是否显示坐标轴刻度
				},
				axisLabel:{//坐标轴刻度标签
					show:true,//是否显示刻度标签
					interval:0,//坐标轴刻度标签的显示间隔
					textStyle:{//刻度标签文字的颜色
						color:'#a2b0b3'
					}
				},
                data: [NDays(4),NDays(3),NDays(2),NDays(1),NDays(0)]
            },
            yAxis: {//直角坐标系 grid 中的 y 轴
            	position:'left',//y 轴的位置
				axisLine: {//坐标轴轴线
					show : false//是否显示坐标轴轴线
				},
				axisTick:{//坐标轴刻度
					show : false//是否显示坐标轴刻度
				},
				axisLabel:{//坐标轴刻度标签
					textStyle:{//刻度标签文字的颜色
						color:'#a2b0b3'
					}
				},
				splitNumber:3,//坐标轴的分割段数
				splitLine:{//坐标轴在 grid 区域中的分隔线
					lineStyle:{//分隔线颜色
						color:'#607884'
					}
				}
			},
            series: [{//系列列表。每个系列通过 type 决定自己的图表类型
                type: 'line',//折线/面积图
				symbol:'image://../static/img/yuan01.png',//标记的图形
				symbolSize: 10,//标记的大小
				legendHoverLink:true,//是否启用图例 hover 时的联动高亮
				label : {//图形上的文本标签
					normal: {
						show: true,//是否显示标签
						textStyle:{//标签的字体样式
							color:'#fff',
							fontStyle: 'normal',
							fontWeight: 400,
							fontFamily: 'sans-serif',
							fontSize: 13,
						}
					}
				},
				connectNulls:false,//是否连接空数据
                data: [],
				lineStyle: {//线条样式
					normal:{
						color:'#2694eb',
						width:3,
						type:'solid'
					}
				},
				smooth:true//是否平滑曲线显示
            },{
                type: 'line',//折线/面积图
                symbolSize:0,//标记的大小
				label : {//图形上的文本标签
					normal: {//是否显示标签
						show: false
					}
				},
				connectNulls:false,//是否连接空数据
                data: [],
				lineStyle: {//线条样式
					normal:{
						color:'#9ccdf5',
						width:3,
						type:'dettod'
					}
					
				},
				smooth:true//是否平滑曲线显示
            }]
        };
		_option = $.extend(true,{},_option,this.options.data);
		this.options.showtips == false ? _option.series[0].symbolSize = 0 : _option.series[0].symbolSize = 10;
		return _option;
	},
	dateZoomline: function(){
		var _option = {
            tooltip: {//提示框组件
				show:false,//是否显示提示框组件
				position: function (point, params, dom) {//提示框浮层的位置
					return [point[0]-45, point[1]-40];
				},
				backgroundColor:"",//提示框浮层的背景颜色
				formatter:'<p style="display:inline-block;padding-bottom:10px;background:url(../static/img/label1.png) no-repeat bottom center;background-size:13px 10px;"><span style="padding:3px 5px;background-color:#2692ea;border-radius:14px">{c0}</span></p>',//提示框浮层内容格式器
				trigger:'trigger'//提示框触发的条件
			},
			grid:{//直角坐标系内绘图网格
				left:'left',//组件离容器左侧的距离
				top:'10',
				right:'0',
				bottom:'0',
				containLabel:true//grid 区域是否包含坐标轴的刻度标签
			},
            xAxis: {//直角坐标系 grid 中的 x 轴
				axisLine: {//坐标轴轴线
					show : false
				},
				axisTick:{//坐标轴刻度
					show : false
				},
				axisLabel:{//坐标轴刻度标签
					textStyle:{
						color:'#fff'
					}
				},
				splitNumber:7,//坐标轴的分割段数
				splitLine:{//坐标轴在 grid 区域中的分隔线
					interval:0,//坐标轴分隔线的显示间隔
					lineStyle:{
						color:'#607884'
					}
				},
                data: []
            },
            yAxis: {
				axisLine: {//坐标轴轴线
					show : false
				},
				axisTick:{//坐标轴刻度
					show : false
				},
				axisLabel:{//坐标轴刻度标签
					inside:true,//刻度标签是否朝内
					textStyle:{
						color:'#fff'
					}
				},
				splitNumber:3//坐标轴的分割段数
			},
			dataZoom:[//组件 用于区域缩放
				{
					type: 'inside',//内置型数据区域缩放组件
					show: true,
					startValue:(new Date().getMonth()-5)+"月",//数据窗口范围的起始数值
					endValue:(new Date().getMonth()+1)+"月"//数据窗口范围的结束数值
				}
			],
            series: [{//系列列表。每个系列通过 type 决定自己的图表类型
                type: 'line',//折线/面积图
				symbolSize: 0,//标记的大小
				legendHoverLink:true,//是否启用图例 hover 时的联动高亮
				label : {//图形上的文本标签
					normal: {
						show: false,
						textStyle:{
							color:'#fff',
							fontStyle: 'normal',
							fontWeight: 400,
							fontFamily: 'sans-serif',
							fontSize: 20,
						}
					}
				},
				connectNulls:true,//是否连接空数据
                data: [],
				lineStyle: {//线条样式
					normal:{
						color:'#2694eb',
						width:2,
						type:'solid'
					}
					
				},
				markPoint:{//图表标注
					data: [//标注的数据数组
						{
							symbol:'image://../static/img/label.png',//标记的图形
							symbolSize:[90,43],//标记的大小
							symbolOffset:[0, '-150%'],//标记相对于原本位置的偏移
							itemStyle:{//标注的样式
								normal:{
									color:'#fff'
								}
							},
							label:{//标签
								normal:{
									color:'#fff',
									position:[10,8],
									textStyle:{
										fontSize:16
									}
								}
							}
						}
					]
				},
				smooth:true//是否平滑曲线显示
            },{
                type: 'line',//折线/面积图
				symbolSize: 0,//标记的大小
				legendHoverLink:true,//是否启用图例 hover的联动高亮
				label : {//图形上的文本标签
					normal: {
						show: false,
						textStyle:{//标签的字体样式
							color:'#fff',
							fontStyle: 'normal',
							fontWeight: 400,
							fontFamily: 'sans-serif',
							fontSize: 20,
						}
					}
				},
				connectNulls:true,//是否连接空数据
                data: [],
				lineStyle: {//线条样式
					normal:{
						color:'#a0d3f2',
						width:2,
						type:'solid'
					}
					
				},
				markPoint:{//图表标注
					data: [
						{
							symbol:'image://../static/img/label.png',//标记的图形
							symbolSize:[90,43],//标记的大小
							symbolOffset:[0, '-150%'],//标记相对于原本位置的偏移
							itemStyle:{//折线拐点标志的样式
								normal:{
									color:'#fff'
								}
							},
							label:{//图形上的文本标签
								normal:{
									color:'#fff',
									position:[10,8],
									textStyle:{
										fontSize:16
									}
								}
							}
						}
					]
				},
				smooth:true
            }]
        };
		_option = $.extend(true,{},_option,this.options.data);
		return _option;
	},
	pie: function(){//饼图
		var _this = this;
		var label = {normal:{position:'inside',textStyle:{fontSize: 12}}};
		for(i = 0;i < this.options.data.length; i++){
			this.options.data[i].label = label;
		}
		var _option = {
				series : [
					{
			            type: 'pie',//
			            clockwise: false,//饼图的扇区是否是顺时针排布
			            hoverAnimation:false,//是否开启 hover 在扇区上的放大动画效果
			            radius : '85%', //控制饼图大小
			            center: ['50%', '50%'],//饼图的中心（圆心）坐标
			            selectedOffset : 5,//选中扇区的偏移距离
			            data:_this.options.data,//系列中的数据内容数组
			            color:[new echarts.graphic.LinearGradient(0, 0, 0, 1, [{offset:0, color:'#42a6f4'}, {offset:1, color:'#308bd4'}], false),'#9ecef4'],
			            itemStyle: {//图形样式
			                emphasis: {
			                    shadowBlur: 10,//图形阴影的模糊大小
			                    shadowOffsetX: 0,//阴影水平方向上的偏移距离
			                    shadowColor: 'rgba(0, 0, 0, 0.5)'//阴影颜色
			                }
			            }
			        }
			    ]
		};
		return _option;
	}
}
;(function() {
	$.fn.setCharts = function(options) {
		$(this).each(function(){
			var Fill = new FillChart(this,options);
			Fill.init();
		})
	}
})(jQuery);



//是否是小数，是：2，否：0
function hasDot(num) {
	if (!isNaN(num)) {
		return ((num + '').indexOf('.') != -1) ? 2 : 0;
	}
}
var NDays = function(n){
	var time = new Date();
	var newTime=time-n*24*60*60*1000;
	var _date = new Date(newTime);
	var _m = (_date.getMonth()+1) < 10 ?  "0"+(_date.getMonth()+1) : (_date.getMonth()+1);
	var _day = _date.getDate()<10 ?  "0"+ _date.getDate() : _date.getDate();
	return _m+'/'+_day;
};
var Mdays = function(n){
	var time = new Date();
	var _y = time.getFullYear();
	var _m = time.getMonth() + 1 - n % 12 ;
	_m = _m <= 0 ? 12 + _m : _m;
	if(time.getMonth()+ 1 - n <= 0){
		_y = _y - 1 - Math.floor((n - time.getMonth() - 1) / 12);
	}
	_m = _m < 10 ?  "0"+_m : _m;
	return _y+'/'+ _m;
}
var FDays = function(n){
	var time = new Date();
	var newTime=time-n*24*60*60*1000;
	var _date = new Date(newTime);
	var _m = (_date.getMonth()+1) < 10 ?  "0"+(_date.getMonth()+1) : (_date.getMonth()+1);
	var _day = _date.getDate()<10 ?  "0"+ _date.getDate() : _date.getDate();
	return _date.getFullYear()+'/'+_m+'/'+_day;
};